/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.part;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.mosp.common.CommonConst;
import jp.mosp.common.part.BasePart;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.TimeUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.dao.CmWorkTypeDao;
import jp.mosp.kintai.common.dto.CmWorkTypeDto;

/**
 * 勤務形態に関するPartクラス
 * @author yoshida
 *	@version	0.0.5
 */
public class WorkTypePart extends BasePart {
	
	/**
	 * コンストラクタ
	 */
	public WorkTypePart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo Partを利用する際に必要な情報
	 */
	public WorkTypePart(PartInfo partInfo) {
		super(partInfo);
	}
	

	/**
	 * MWorkTypeDaoインスタンス
	 */
	private CmWorkTypeDao	workTypeDao;
	

	/**
	 * CM_WORKTYPEテーブル用DAOの取得
	 * @return	初期化済みMWorkTypeDaoインスタンス
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmWorkTypeDao getCmWorkTypeDao() throws Exception {
		if (VariousUtil.isNull(workTypeDao)) {
			workTypeDao = (CmWorkTypeDao)getPreparedDao(CmWorkTypeDao.class.getCanonicalName());
		}
		return workTypeDao;
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getWorkTypeArrayNotDeleted() throws Exception {
		// 情報の取得
		List<CmWorkTypeDto> listWorkType = findAvailable();
		// 配列の作成
		String[][] aryWorkType = new String[listWorkType.size()][2];
		for (int i = 0; i < aryWorkType.length; i++) {
			aryWorkType[i][0] = listWorkType.get(i).getShiftCode();
			aryWorkType[i][1] = listWorkType.get(i).getShiftName();
		}
		return aryWorkType;
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)（週休付）
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getWorkTypeArrayWithWeekHoliday() throws Exception {
		return StringUtil.addArrayLastRowValue(getWorkTypeArrayNotDeleted(), CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY,
				CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY);
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getWorkTypeArrayAll() throws Exception {
		// 情報の取得
		List<CmWorkTypeDto> listWorkType = findAll();
		// 配列の作成
		String[][] aryWorkType = new String[listWorkType.size()][2];
		for (int i = 0; i < aryWorkType.length; i++) {
			aryWorkType[i][0] = listWorkType.get(i).getShiftCode();
			aryWorkType[i][1] = listWorkType.get(i).getShiftName();
		}
		return aryWorkType;
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[] getWorkTypeCodeArrayAll() throws Exception {
		// 情報の取得
		List<CmWorkTypeDto> listWorkType = findAll();
		// 配列の作成
		String[] aryWorkType = new String[listWorkType.size()];
		for (int i = 0; i < aryWorkType.length; i++) {
			aryWorkType[i] = listWorkType.get(i).getShiftCode();
		}
		return aryWorkType;
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	private String[][] getWorkTypeArrayAllWithWeekHoliday() throws Exception {
		return StringUtil.addArrayLastRowValue(getWorkTypeArrayAll(), CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY,
				CommonConst.NAM_STANDARD_WEEK_HOLIDAY);
	}
	
	/**
	 * 勤務形態コード（所定休日、法定休日を含む）取得(CM_WORKTYPE)
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getWorkTypeArrayAllWithHoliday() throws Exception {
		return StringUtil.addArrayLastRowValue(getWorkTypeArrayAllWithWeekHoliday(),
				CommonConst.ATTENDANCE_TYPE_OFFICIAL_HOLIDAY, CommonConst.NAM_OFFICIAL_HOLIDAY);
	}
	
	/**
	 * 勤務形態情報取得(CM_WORKTYPE)
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getWorkTypeDataArray() throws Exception {
		// 情報の取得
		List<CmWorkTypeDto> listWorkType = findAll();
		// 配列の作成
		String[][] aryWorkType = new String[listWorkType.size()][8];
		for (int i = 0; i < aryWorkType.length; i++) {
			aryWorkType[i][0] = listWorkType.get(i).getShiftCode();
			aryWorkType[i][1] = listWorkType.get(i).getShiftName();
			aryWorkType[i][2] = String.valueOf(listWorkType.get(i).getStartTime());
			aryWorkType[i][3] = String.valueOf(listWorkType.get(i).getQuitTime());
			aryWorkType[i][4] = String.valueOf(listWorkType.get(i).getWorkTime());
			aryWorkType[i][5] = String.valueOf(listWorkType.get(i).getBreakTime());
			aryWorkType[i][6] = String.valueOf(listWorkType.get(i).getOverStart());
			aryWorkType[i][7] = String.valueOf(listWorkType.get(i).getOverBreak());
		}
		return aryWorkType;
	}
	

	/**
	 * 勤務形態マップ
	 */
	private Map<String, CmWorkTypeDto>	workTypeMap;
	

	/**
	 * 勤務形態マップ取得
	 * @return 勤務形態マップ
	 * @throws Exception  例外処理が発生した場合
	 */
	public Map<String, CmWorkTypeDto> getWorkTypeMap() throws Exception {
		if (VariousUtil.isNull(workTypeMap)) {
			// 情報の取得
			List<CmWorkTypeDto> listWorkType = findAll();
			// Mapの作成
			workTypeMap = new HashMap<String, CmWorkTypeDto>();
			for (CmWorkTypeDto dto : listWorkType) {
				workTypeMap.put(dto.getShiftCode(), dto);
			}
		}
		return workTypeMap;
	}
	
	/**
	 * 勤務形態マップ(週休、法休を含む)取得
	 * @return  勤務形態マップ
	 * @throws Exception  例外処理が発生した場合
	 */
	public Map<String, CmWorkTypeDto> getWorkTypeAllMap() throws Exception {
		workTypeMap = getWorkTypeMap();
		// 週休（所定休日）
		CmWorkTypeDto weekHolidayDto = new CmWorkTypeDto();
		weekHolidayDto.setShiftCode(CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY);
		weekHolidayDto.setShiftName(CommonConst.NAM_STANDARD_WEEK_HOLIDAY);
		workTypeMap.put(weekHolidayDto.getShiftCode(), weekHolidayDto);
		// 法休（法定休日）
		CmWorkTypeDto officialHolidayDto = new CmWorkTypeDto();
		officialHolidayDto.setShiftCode(CommonConst.ATTENDANCE_TYPE_OFFICIAL_HOLIDAY);
		officialHolidayDto.setShiftName(CommonConst.NAM_OFFICIAL_HOLIDAY);
		workTypeMap.put(officialHolidayDto.getShiftCode(), officialHolidayDto);
		return workTypeMap;
	}
	
	/**
	 * 勤務形態情報取得(週休、法休を含む)
	 * @since	0.0.2
	 * @param shiftCode		対象勤務形態コード
	 * @return	検索結果(DTO)
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmWorkTypeDto getWorkTypeInfo(String shiftCode) throws Exception {
		return getWorkTypeAllMap().get(shiftCode);
	}
	
	/**
	 * 勤務形態情報取得(利用可能のみ)
	 * @since	0.0.2
	 * @param shiftCode		対象勤務形態コード
	 * @return	検索結果(DTO)
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmWorkTypeDto getAvailableWorkTypeInfo(String shiftCode) throws Exception {
		return getCmWorkTypeDao().findForAvailable(shiftCode);
	}
	
	/**
	 * 勤務形態情報取得
	 * @since	0.0.3
	 * @param shiftCode		対象勤務形態コード
	 * @return	検索結果(DTO)
	 * @throws Exception 例外処理が発生した場合
	 */
	public CmWorkTypeDto findForKey(String shiftCode) throws Exception {
		return getCmWorkTypeDao().findForKey(shiftCode);
	}
	
	/**
	 * 勤務形態名称取得
	 * @since	0.0.3
	 * @param shiftCode		対象勤務形態コード
	 * @return	勤務形態名称
	 * @throws Exception 例外処理が発生した場合
	 */
	public String getWorkTypeName(String shiftCode) throws Exception {
		return getWorkTypeName(shiftCode, false);
	}
	
	/**
	 * 勤務形態名称取得
	 * @param shiftCode	 	対象勤務形態コード
	 * @param addTime 時刻情報表示フラグ
	 * @return 勤務形態名称
	 * @throws Exception 例外処理が発生した場合
	 */
	public String getWorkTypeName(String shiftCode, boolean addTime) throws Exception {
		CmWorkTypeDto dto = getWorkTypeAllMap().get(shiftCode);
		if (VariousUtil.isNotNull(dto)) {
			if (addTime) {
				return getWorkTypeNameForView(dto);
			}
			return dto.getShiftName();
		}
		return shiftCode;
	}
	
	/**
	 * 勤務形態リスト取得(開始、終了時刻付き)(利用可能のみ)
	 * @since	0.0.4
	 * @return	勤務形態リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[][] getWorkTypeInfoArray() throws Exception {
		List<CmWorkTypeDto> list = findAvailable();
		String[][] aryWorkType = new String[list.size()][2];
		int i = 0;
		for (CmWorkTypeDto dto : list) {
			aryWorkType[i][0] = dto.getShiftCode();
			aryWorkType[i][1] = getWorkTypeNameForView(dto);
			i++;
		}
		return aryWorkType;
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)（週休付）
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	private String[][] getWorkTypeInfoArrayWithWeekHoliday() throws Exception {
		return StringUtil.addArrayLastRowValue(getWorkTypeInfoArray(), CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY,
				CommonConst.NAM_STANDARD_WEEK_HOLIDAY);
	}
	
	/**
	 * 勤務形態コード取得(CM_WORKTYPE)（週休、法定休日付）
	 * @return 勤務形態コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getWorkTypeInfoArrayWithHoliday() throws Exception {
		return StringUtil.addArrayLastRowValue(getWorkTypeInfoArrayWithWeekHoliday(),
				CommonConst.ATTENDANCE_TYPE_OFFICIAL_HOLIDAY, CommonConst.NAM_OFFICIAL_HOLIDAY);
	}
	
	/**
	 * 勤務形態リスト取得(利用可能のみ)
	 * @since	0.0.5
	 * @return	勤務形態リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public List<CmWorkTypeDto> findAvailable() throws Exception {
		return getCmWorkTypeDao().findAvailable();
	}
	
	/**
	 * 勤務形態リスト取得
	 * @since	0.0.5
	 * @return	勤務形態リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public List<CmWorkTypeDto> findAll() throws Exception {
		return getCmWorkTypeDao().findAll();
	}
	
	/**
	 * 勤務形態時刻情報取得
	 * @since	0.0.5
	 * @param dto			対象DTO
	 * @return	勤務形態時刻情報
	 */
	public static String getWorkTypeTimeForView(CmWorkTypeDto dto) {
		StringBuffer sb = new StringBuffer();
		if (VariousUtil.isNotNull(dto)) {
			sb.append(TimeUtil.convIntegerTimeToStringTime(dto.getStartTime()));
			sb.append(CommonConst.STR_TERM);
			sb.append(TimeUtil.convIntegerTimeToStringTime(dto.getQuitTime()));
			return StringUtil.surroundBracket(sb.toString());
		}
		return sb.toString();
	}
	
	/**
	 * 勤務形態名称(開始、終了時刻付き)取得
	 * @since	0.0.5
	 * @param dto			対象DTO
	 * @return	勤務形態名称(開始、終了時刻付き)
	 */
	public static String getWorkTypeNameForView(CmWorkTypeDto dto) {
		StringBuffer sb = new StringBuffer();
		if (VariousUtil.isNotNull(dto)) {
			sb.append(dto.getShiftName());
			sb.append(getWorkTypeTimeForView(dto));
		}
		return sb.toString();
	}
	
	/**
	 * 勤務形態名称(開始、終了時刻付き)取得
	 * @since	0.0.5
	 * @param shiftCode		対象勤務形態コード
	 * @return	勤務形態名称(開始、終了時刻付き)
	 * @throws Exception 例外処理が発生した場合
	 */
	public String getWorkTypeNameForView(String shiftCode) throws Exception {
		return getWorkTypeNameForView(findForKey(shiftCode));
	}
	
}
